(: Copyright(c) 2007-2008. Progress Software Corporation. All Rights Reserved. :)
import module namespace common = "http://www.datadirect.com/examples/XQueryWebService" at "common.xquery";

declare variable $queryFiles as element(*, xs:untyped) * external;
declare variable $location as xs:string external;
declare variable $targetNamespace as xs:string external;

declare option ddtek:serialize "indent=yes,omit-xml-declaration=no";

<wsdl:definitions targetNamespace="http://www.datadirect.com" 
	xmlns:dd="http://www.datadirect.com"
	xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" 
	xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
	xmlns:http="http://schemas.xmlsoap.org/wsdl/http/"
	xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/"
	xmlns:dynamic='DYNAMIC_NAMESPACE_DECLARATIONS'>
	
	<wsdl:types>
		<xs:schema 
			attributeFormDefault="unqualified"
			elementFormDefault="qualified" 
			targetNamespace="http://www.datadirect.com">
			{
			for $xsdImport in $queryFiles/imports/import
			return 
				<xs:import schemaLocation="{$xsdImport/@location}">{
					if(string-length(string($xsdImport/@namespace)) > 0) then
						attribute namespace {$xsdImport/@namespace} 
					else ()
				}</xs:import>
			,
			
			for $xq in $queryFiles/query
			return $xq/input/type/*
			,
			<xs:element name="Output" type="xs:anyType"/>
			}
		</xs:schema>
	</wsdl:types>
    { 
	  for $xq in $queryFiles/query
	  return
	  (
	    <wsdl:message  name="{$xq/@name}InputMsg">
			<wsdl:part name="parameters" element="dd:{$xq/@name}"/>
		</wsdl:message>
		, 
		for $outputElement in $xq/output/element
		return(  
			let $elementName := QName($outputElement/@namespace, $outputElement/@local-name) 
			return
			<wsdl:message name="{$xq/@name}OutputMsg">
				<wsdl:part name="parameters" element="{$elementName}"/>
			</wsdl:message>
			)
	  )
	  ,
	  <wsdl:message name="OutputMsg">
	  	<wsdl:part name="Output" element="dd:Output"/>
	  </wsdl:message>
	  ,
	  <wsdl:message name="FaultMsg"/>
    }
  
  <wsdl:portType name="SOAPPort">{
	for $xq in $queryFiles/query
  	return
	    <wsdl:operation name="{$xq/@name}">
	      <wsdl:input message="dd:{$xq/@name}InputMsg" />
	      {
	      let $msgName := if($xq/output/element) then $xq/@name else () return 
	      <wsdl:output message="dd:{$msgName}OutputMsg"/>
	      }
	      <wsdl:fault name="nmtoken" message="dd:FaultMsg"/>
	    </wsdl:operation>}
  </wsdl:portType>
  
  <wsdl:portType name="HTTPGETPort">
    {
	for $xq in $queryFiles/query
  	return
    	<wsdl:operation name="{$xq/@name}">
    	  <wsdl:input message="dd:{$xq/@name}InputMsg" />
	      {
	      let $msgName := if($xq/output/element) then $xq/@name else () return 
	      <wsdl:output message="dd:{$msgName}OutputMsg"/>
	      }
	      <wsdl:fault name="nmtoken" message="dd:FaultMsg"/>
    	</wsdl:operation>
    }
  </wsdl:portType>
  
  
  <wsdl:binding name="SOAPBinding" type="dd:SOAPPort">
    <wsdlsoap:binding style="document" transport="http://schemas.xmlsoap.org/soap/http"/>
	{
	for $xq in $queryFiles/query
  	return
		<wsdl:operation name="{$xq/@name}">
	      <wsdlsoap:operation style="document" soapAction="{$xq/@fileName}"/>
	      <wsdl:input>
	       <wsdlsoap:body use="literal"/>
	      </wsdl:input>
		  <wsdl:output>
		  	<wsdlsoap:body use="literal"/>
	      </wsdl:output>
	      <wsdl:fault name="nmtoken"/>
	    </wsdl:operation>
	}
  </wsdl:binding>
  
  <wsdl:binding name="HTTPGETBinding" type="dd:HTTPGETPort">
    <http:binding verb="GET" />
    {
    for $xq in $queryFiles/query
  	return
    <wsdl:operation name="{$xq/@name}">
      <http:operation location="{concat('/', $xq/@name)}" />
      <wsdl:input>
        <http:urlEncoded />
      </wsdl:input>
      <wsdl:output>
        <mime:mimeXml part="Body" />
      </wsdl:output>
    </wsdl:operation>
    }
  </wsdl:binding>
  

  <wsdl:service name="Service">
    <wsdl:port name="SOAPPort" binding="dd:SOAPBinding">
      <wsdlsoap:address location="{$location}"/>
    </wsdl:port>
    <wsdl:port name="HTTPGETPort" binding="dd:HTTPGETBinding">
      <http:address location="{$location}"/>
    </wsdl:port>
  </wsdl:service>
</wsdl:definitions>